/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIO16V2;

/**
 * Passes through actions of the IO-16 Bricklet 2.0.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIO16V2Actions implements ThingActions, IBrickletIO16V2Actions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletIO16V2Actions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletIO16V2Actions.class.getName())) {
            if (actions instanceof IBrickletIO16V2Actions) {
                return (IBrickletIO16V2Actions) actions;
            } else {
                return (IBrickletIO16V2Actions) Proxy.newProxyInstance(IBrickletIO16V2Actions.class.getClassLoader(),
                        new Class[] { IBrickletIO16V2Actions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletIO16V2Actions");
    }

        @Override
    @RuleAction(label = "Set Value")
    public void brickletIO16V2SetValue(
            @ActionInput(name = "value") boolean[] value) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setValue(value);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output15"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15"), RefreshType.REFRESH);
}
    }

    public static void brickletIO16V2SetValue(@Nullable ThingActions actions, boolean[] value) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIO16V2SetValue(value);
    }

    @Override
    @RuleAction(label = "Set Selected Value")
    public void brickletIO16V2SetSelectedValue(
            @ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setSelectedValue(channel, value);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output15"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15"), RefreshType.REFRESH);
}
    }

    public static void brickletIO16V2SetSelectedValue(@Nullable ThingActions actions, int channel, boolean value) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIO16V2SetSelectedValue(channel, value);
    }

    @Override
    @RuleAction(label = "Set Monoflop")
    public void brickletIO16V2SetMonoflop(
            @ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value,
            @ActionInput(name = "time") long time) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setMonoflop(channel, value, time);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Output15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Output15"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2Monoflop15"), RefreshType.REFRESH);
}
    }

    public static void brickletIO16V2SetMonoflop(@Nullable ThingActions actions, int channel, boolean value, long time) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIO16V2SetMonoflop(channel, value, time);
    }


    @Override
    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "value", type="boolean[]")
           Map<String, Object> brickletIO16V2GetValue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        boolean[] value = dev.getValue();
        
        result.put("value", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetValue(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetValue();
    }


    @Override
    @RuleAction(label = "Get Configuration")
    public @ActionOutput(name = "direction", type="char")
           @ActionOutput(name = "value", type="boolean")
           Map<String, Object> brickletIO16V2GetConfiguration(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIO16V2.Configuration value = dev.getConfiguration(channel);
        
        result.put("direction", value.direction);
        result.put("value", value.value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetConfiguration(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetConfiguration(channel);
    }


    @Override
    @RuleAction(label = "Get Edge Count")
    public @ActionOutput(name = "count", type="long")
           Map<String, Object> brickletIO16V2GetEdgeCount(
            @ActionInput(name = "channel") int channel,
            @ActionInput(name = "resetCounter") boolean resetCounter) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        Thing t = h.getThing();
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        long value = dev.getEdgeCount(channel, resetCounter);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount4")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount4"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount5")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount5"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount6")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount6"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount7")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount7"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount8")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount8"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount9")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount9"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount10")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount10"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount11")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount11"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount12")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount12"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount13")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount13"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount14")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount14"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount15")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIO16V2EdgeCount15"), RefreshType.REFRESH);
}
        result.put("count", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetEdgeCount(@Nullable ThingActions actions, int channel, boolean resetCounter) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetEdgeCount(channel, resetCounter);
    }


    @Override
    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type="boolean")
           @ActionOutput(name = "time", type="long")
           @ActionOutput(name = "timeRemaining", type="long")
           Map<String, Object> brickletIO16V2GetMonoflop(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIO16V2.Monoflop value = dev.getMonoflop(channel);
        
        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetMonoflop(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetMonoflop(channel);
    }


    @Override
    @RuleAction(label = "Get Edge Count Configuration")
    public @ActionOutput(name = "edgeType", type="int")
           @ActionOutput(name = "debounce", type="int")
           Map<String, Object> brickletIO16V2GetEdgeCountConfiguration(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIO16V2.EdgeCountConfiguration value = dev.getEdgeCountConfiguration(channel);
        
        result.put("edgeType", value.edgeType);
        result.put("debounce", value.debounce);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetEdgeCountConfiguration(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetEdgeCountConfiguration(channel);
    }


    @Override
    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletIO16V2ReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        long value = dev.readUID();
        
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2ReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2ReadUID();
    }


    @Override
    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletIO16V2GetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();
        
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetChipTemperature();
    }


    @Override
    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIO16V2GetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetStatusLEDConfig();
    }


    @Override
    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletIO16V2GetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIO16V2.SPITFPErrorCount value = dev.getSPITFPErrorCount();
        
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetSPITFPErrorCount();
    }

    @Override
    @RuleAction(label = "Reset")
    public void brickletIO16V2Reset(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.reset();
        
    }

    public static void brickletIO16V2Reset(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIO16V2Reset();
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIO16V2GetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIO16V2Wrapper dev = ((@Nullable BrickletIO16V2Wrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIO16V2.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIO16V2GetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIO16V2GetIdentity();
    }
}
