/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIndustrialDualRelay;

/**
 * Passes through actions of the Industrial Dual Relay Bricklet.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialDualRelayActions implements ThingActions, IBrickletIndustrialDualRelayActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletIndustrialDualRelayActions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletIndustrialDualRelayActions.class.getName())) {
            if (actions instanceof IBrickletIndustrialDualRelayActions) {
                return (IBrickletIndustrialDualRelayActions) actions;
            } else {
                return (IBrickletIndustrialDualRelayActions) Proxy.newProxyInstance(IBrickletIndustrialDualRelayActions.class.getClassLoader(),
                        new Class[] { IBrickletIndustrialDualRelayActions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletIndustrialDualRelayActions");
    }

        @Override
    @RuleAction(label = "Set Value")
    public void brickletIndustrialDualRelaySetValue(
            @ActionInput(name = "channel0") boolean channel0,
            @ActionInput(name = "channel1") boolean channel1) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setValue(channel0, channel1);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDualRelaySetValue(@Nullable ThingActions actions, boolean channel0, boolean channel1) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialDualRelaySetValue(channel0, channel1);
    }

    @Override
    @RuleAction(label = "Set Selected Value")
    public void brickletIndustrialDualRelaySetSelectedValue(
            @ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setSelectedValue(channel, value);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDualRelaySetSelectedValue(@Nullable ThingActions actions, int channel, boolean value) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialDualRelaySetSelectedValue(channel, value);
    }

    @Override
    @RuleAction(label = "Set Monoflop")
    public void brickletIndustrialDualRelaySetMonoflop(
            @ActionInput(name = "channel") int channel,
            @ActionInput(name = "value") boolean value,
            @ActionInput(name = "time") long time) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setMonoflop(channel, value, time);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialDualRelayMonoflopRelay1"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialDualRelaySetMonoflop(@Nullable ThingActions actions, int channel, boolean value, long time) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialDualRelaySetMonoflop(channel, value, time);
    }


    @Override
    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "channel0", type="boolean")
           @ActionOutput(name = "channel1", type="boolean")
           Map<String, Object> brickletIndustrialDualRelayGetValue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDualRelay.Value value = dev.getValue();
        
        result.put("channel0", value.channel0);
        result.put("channel1", value.channel1);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetValue(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetValue();
    }


    @Override
    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type="boolean")
           @ActionOutput(name = "time", type="long")
           @ActionOutput(name = "timeRemaining", type="long")
           Map<String, Object> brickletIndustrialDualRelayGetMonoflop(
            @ActionInput(name = "channel") int channel) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDualRelay.Monoflop value = dev.getMonoflop(channel);
        
        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetMonoflop(@Nullable ThingActions actions, int channel) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetMonoflop(channel);
    }


    @Override
    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletIndustrialDualRelayReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        long value = dev.readUID();
        
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayReadUID();
    }


    @Override
    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletIndustrialDualRelayGetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();
        
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetChipTemperature();
    }


    @Override
    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletIndustrialDualRelayGetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetStatusLEDConfig();
    }


    @Override
    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletIndustrialDualRelayGetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDualRelay.SPITFPErrorCount value = dev.getSPITFPErrorCount();
        
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetSPITFPErrorCount();
    }

    @Override
    @RuleAction(label = "Reset")
    public void brickletIndustrialDualRelayReset(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.reset();
        
    }

    public static void brickletIndustrialDualRelayReset(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialDualRelayReset();
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialDualRelayGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialDualRelayWrapper dev = ((@Nullable BrickletIndustrialDualRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialDualRelay.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialDualRelayGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialDualRelayGetIdentity();
    }
}
