/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletIndustrialQuadRelay;

/**
 * Passes through actions of the Industrial Quad Relay Bricklet.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletIndustrialQuadRelayActions implements ThingActions, IBrickletIndustrialQuadRelayActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletIndustrialQuadRelayActions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletIndustrialQuadRelayActions.class.getName())) {
            if (actions instanceof IBrickletIndustrialQuadRelayActions) {
                return (IBrickletIndustrialQuadRelayActions) actions;
            } else {
                return (IBrickletIndustrialQuadRelayActions) Proxy.newProxyInstance(IBrickletIndustrialQuadRelayActions.class.getClassLoader(),
                        new Class[] { IBrickletIndustrialQuadRelayActions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletIndustrialQuadRelayActions");
    }

        @Override
    @RuleAction(label = "Set Value")
    public void brickletIndustrialQuadRelaySetValue(
            @ActionInput(name = "valueMask") int valueMask) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setValue(valueMask);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialQuadRelaySetValue(@Nullable ThingActions actions, int valueMask) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialQuadRelaySetValue(valueMask);
    }

    @Override
    @RuleAction(label = "Set Monoflop")
    public void brickletIndustrialQuadRelaySetMonoflop(
            @ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask,
            @ActionInput(name = "time") long time) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setMonoflop(selectionMask, valueMask, time);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialQuadRelaySetMonoflop(@Nullable ThingActions actions, int selectionMask, int valueMask, long time) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialQuadRelaySetMonoflop(selectionMask, valueMask, time);
    }

    @Override
    @RuleAction(label = "Set Selected Values")
    public void brickletIndustrialQuadRelaySetSelectedValues(
            @ActionInput(name = "selectionMask") int selectionMask,
            @ActionInput(name = "valueMask") int valueMask) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        Thing t = h.getThing();
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setSelectedValues(selectionMask, valueMask);
        if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayRelay3"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay0"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay1"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay2"), RefreshType.REFRESH);
}
if(t.getChannel(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3")) != null){
	h.handleCommand(new ChannelUID(t.getUID(), "BrickletIndustrialQuadRelayMonoflopRelay3"), RefreshType.REFRESH);
}
    }

    public static void brickletIndustrialQuadRelaySetSelectedValues(@Nullable ThingActions actions, int selectionMask, int valueMask) throws TinkerforgeException {
        invokeMethodOf(actions).brickletIndustrialQuadRelaySetSelectedValues(selectionMask, valueMask);
    }


    @Override
    @RuleAction(label = "Get Value")
    public @ActionOutput(name = "valueMask", type="int")
           Map<String, Object> brickletIndustrialQuadRelayGetValue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getValue();
        
        result.put("valueMask", value);
        return result;
    }

    public static Map<String, Object> brickletIndustrialQuadRelayGetValue(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialQuadRelayGetValue();
    }


    @Override
    @RuleAction(label = "Get Monoflop")
    public @ActionOutput(name = "value", type="int")
           @ActionOutput(name = "time", type="long")
           @ActionOutput(name = "timeRemaining", type="long")
           Map<String, Object> brickletIndustrialQuadRelayGetMonoflop(
            @ActionInput(name = "pin") short pin) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialQuadRelay.Monoflop value = dev.getMonoflop(pin);
        
        result.put("value", value.value);
        result.put("time", value.time);
        result.put("timeRemaining", value.timeRemaining);
        return result;
    }

    public static Map<String, Object> brickletIndustrialQuadRelayGetMonoflop(@Nullable ThingActions actions, short pin) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialQuadRelayGetMonoflop(pin);
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletIndustrialQuadRelayGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletIndustrialQuadRelayWrapper dev = ((@Nullable BrickletIndustrialQuadRelayWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletIndustrialQuadRelay.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletIndustrialQuadRelayGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletIndustrialQuadRelayGetIdentity();
    }
}
