/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

import java.util.Map;
import java.util.HashMap;

import com.tinkerforge.TinkerforgeException;
import com.tinkerforge.BrickletRGBLEDMatrix;

/**
 * Passes through actions of the RGB LED Matrix Bricklet.
 * @author Erik Fleckstein - Initial contribution
 */
@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletRGBLEDMatrixActions implements ThingActions, IBrickletRGBLEDMatrixActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

    private static IBrickletRGBLEDMatrixActions invokeMethodOf(@Nullable ThingActions actions) {
        if (actions == null) {
            throw new IllegalArgumentException("actions cannot be null");
        }
        if (actions.getClass().getName().equals(BrickletRGBLEDMatrixActions.class.getName())) {
            if (actions instanceof IBrickletRGBLEDMatrixActions) {
                return (IBrickletRGBLEDMatrixActions) actions;
            } else {
                return (IBrickletRGBLEDMatrixActions) Proxy.newProxyInstance(IBrickletRGBLEDMatrixActions.class.getClassLoader(),
                        new Class[] { IBrickletRGBLEDMatrixActions.class }, (Object proxy, Method method, Object[] args) -> {
                            Method m = actions.getClass().getDeclaredMethod(method.getName(),
                                    method.getParameterTypes());
                            return m.invoke(actions, args);
                        });
            }
        }
        throw new IllegalArgumentException("Actions is not an instance of BrickletRGBLEDMatrixActions");
    }

    
    @Override
    @RuleAction(label = "Get Red")
    public @ActionOutput(name = "red", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetRed(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int[] value = dev.getRed();
        
        result.put("red", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetRed(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetRed();
    }


    @Override
    @RuleAction(label = "Get Green")
    public @ActionOutput(name = "green", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetGreen(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int[] value = dev.getGreen();
        
        result.put("green", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetGreen(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetGreen();
    }


    @Override
    @RuleAction(label = "Get Blue")
    public @ActionOutput(name = "blue", type="int[]")
           Map<String, Object> brickletRGBLEDMatrixGetBlue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int[] value = dev.getBlue();
        
        result.put("blue", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetBlue(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetBlue();
    }

    @Override
    @RuleAction(label = "Set Red")
    public void brickletRGBLEDMatrixSetRed(
            @ActionInput(name = "red") int[] red) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setRed(red);
        
    }

    public static void brickletRGBLEDMatrixSetRed(@Nullable ThingActions actions, int[] red) throws TinkerforgeException {
        invokeMethodOf(actions).brickletRGBLEDMatrixSetRed(red);
    }

    @Override
    @RuleAction(label = "Set Green")
    public void brickletRGBLEDMatrixSetGreen(
            @ActionInput(name = "green") int[] green) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setGreen(green);
        
    }

    public static void brickletRGBLEDMatrixSetGreen(@Nullable ThingActions actions, int[] green) throws TinkerforgeException {
        invokeMethodOf(actions).brickletRGBLEDMatrixSetGreen(green);
    }

    @Override
    @RuleAction(label = "Set Blue")
    public void brickletRGBLEDMatrixSetBlue(
            @ActionInput(name = "blue") int[] blue) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.setBlue(blue);
        
    }

    public static void brickletRGBLEDMatrixSetBlue(@Nullable ThingActions actions, int[] blue) throws TinkerforgeException {
        invokeMethodOf(actions).brickletRGBLEDMatrixSetBlue(blue);
    }


    @Override
    @RuleAction(label = "Get Frame Duration")
    public @ActionOutput(name = "frameDuration", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetFrameDuration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getFrameDuration();
        
        result.put("frameDuration", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetFrameDuration(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetFrameDuration();
    }

    @Override
    @RuleAction(label = "Draw Frame")
    public void brickletRGBLEDMatrixDrawFrame(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.drawFrame();
        
    }

    public static void brickletRGBLEDMatrixDrawFrame(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletRGBLEDMatrixDrawFrame();
    }


    @Override
    @RuleAction(label = "Get Supply Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getSupplyVoltage();
        
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSupplyVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetSupplyVoltage();
    }


    @Override
    @RuleAction(label = "Read UID")
    public @ActionOutput(name = "uid", type="long")
           Map<String, Object> brickletRGBLEDMatrixReadUID(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        long value = dev.readUID();
        
        result.put("uid", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixReadUID(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixReadUID();
    }


    @Override
    @RuleAction(label = "Get Chip Temperature")
    public @ActionOutput(name = "temperature", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetChipTemperature(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getChipTemperature();
        
        result.put("temperature", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetChipTemperature(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetChipTemperature();
    }


    @Override
    @RuleAction(label = "Get Status LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        int value = dev.getStatusLEDConfig();
        
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetStatusLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetStatusLEDConfig();
    }


    @Override
    @RuleAction(label = "Get SPITFP Error Count")
    public @ActionOutput(name = "errorCountAckChecksum", type="long")
           @ActionOutput(name = "errorCountMessageChecksum", type="long")
           @ActionOutput(name = "errorCountFrame", type="long")
           @ActionOutput(name = "errorCountOverflow", type="long")
           Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletRGBLEDMatrix.SPITFPErrorCount value = dev.getSPITFPErrorCount();
        
        result.put("errorCountAckChecksum", value.errorCountAckChecksum);
        result.put("errorCountMessageChecksum", value.errorCountMessageChecksum);
        result.put("errorCountFrame", value.errorCountFrame);
        result.put("errorCountOverflow", value.errorCountOverflow);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetSPITFPErrorCount(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetSPITFPErrorCount();
    }

    @Override
    @RuleAction(label = "Reset")
    public void brickletRGBLEDMatrixReset(
            ) throws TinkerforgeException {
        DeviceHandler h = handler;
        if(h == null) {
            return;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return;
        }
        dev.reset();
        
    }

    public static void brickletRGBLEDMatrixReset(@Nullable ThingActions actions) throws TinkerforgeException {
        invokeMethodOf(actions).brickletRGBLEDMatrixReset();
    }


    @Override
    @RuleAction(label = "Get Identity")
    public @ActionOutput(name = "uid", type="String")
           @ActionOutput(name = "connectedUid", type="String")
           @ActionOutput(name = "position", type="char")
           @ActionOutput(name = "hardwareVersion", type="short[]")
           @ActionOutput(name = "firmwareVersion", type="short[]")
           @ActionOutput(name = "deviceIdentifier", type="int")
           Map<String, Object> brickletRGBLEDMatrixGetIdentity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        DeviceHandler h = handler;
        if(h == null) {
            return result;
        }
        
        @Nullable BrickletRGBLEDMatrixWrapper dev = ((@Nullable BrickletRGBLEDMatrixWrapper)h.getDevice());
        if(dev == null) {
            return result;
        }

        BrickletRGBLEDMatrix.Identity value = dev.getIdentity();
        
        result.put("uid", value.uid);
        result.put("connectedUid", value.connectedUid);
        result.put("position", value.position);
        result.put("hardwareVersion", value.hardwareVersion);
        result.put("firmwareVersion", value.firmwareVersion);
        result.put("deviceIdentifier", value.deviceIdentifier);
        return result;
    }

    public static Map<String, Object> brickletRGBLEDMatrixGetIdentity(@Nullable ThingActions actions) throws TinkerforgeException {
        return invokeMethodOf(actions).brickletRGBLEDMatrixGetIdentity();
    }
}
