/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the DC Brick.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickDCActions {

    public void brickDCSetVelocity(short velocity) throws TinkerforgeException;

    public Map<String, Object> brickDCGetVelocity() throws TinkerforgeException;

    public Map<String, Object> brickDCGetCurrentVelocity() throws TinkerforgeException;

    public void brickDCSetAcceleration(int acceleration) throws TinkerforgeException;

    public Map<String, Object> brickDCGetAcceleration() throws TinkerforgeException;

    public void brickDCFullBrake() throws TinkerforgeException;

    public void brickDCEnable() throws TinkerforgeException;

    public void brickDCDisable() throws TinkerforgeException;

    public Map<String, Object> brickDCIsEnabled() throws TinkerforgeException;

    public void brickDCSetPWMFrequency(int frequency) throws TinkerforgeException;

    public Map<String, Object> brickDCGetPWMFrequency() throws TinkerforgeException;

    public Map<String, Object> brickDCGetStackInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickDCGetExternalInputVoltage() throws TinkerforgeException;

    public Map<String, Object> brickDCGetCurrentConsumption() throws TinkerforgeException;

    public void brickDCSetDriveMode(short mode) throws TinkerforgeException;

    public Map<String, Object> brickDCGetDriveMode() throws TinkerforgeException;

    public Map<String, Object> brickDCGetMinimumVoltage() throws TinkerforgeException;

    public Map<String, Object> brickDCGetIdentity() throws TinkerforgeException;

    public Map<String, Object> brickDCIsStatusLEDEnabled() throws TinkerforgeException;

    public Map<String, Object> brickDCGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickDCGetSendTimeoutCount(short communicationMethod) throws TinkerforgeException;

    public Map<String, Object> brickDCGetSPITFPBaudrateConfig() throws TinkerforgeException;

    public Map<String, Object> brickDCGetSPITFPErrorCount(char brickletPort) throws TinkerforgeException;

    public Map<String, Object> brickDCGetSPITFPBaudrate(char brickletPort) throws TinkerforgeException;;
}
