/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the CAN Bricklet 2.0.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletCANV2Actions {

    public Map<String, Object> brickletCANV2WriteFrame(int frameType, long identifier, int[] data) throws TinkerforgeException;

    public Map<String, Object> brickletCANV2ReadFrame() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetTransceiverConfiguration() throws TinkerforgeException;

    public void brickletCANV2SetQueueConfiguration(int writeBufferSize, int writeBufferTimeout, int writeBacklogSize, int[] readBufferSizes, int readBacklogSize) throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetQueueConfiguration() throws TinkerforgeException;

    public void brickletCANV2SetReadFilterConfiguration(int bufferIndex, int filterMode, long filterMask, long filterIdentifier) throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetReadFilterConfiguration(int bufferIndex) throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetErrorLog() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2ReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletCANV2Reset() throws TinkerforgeException;

    public Map<String, Object> brickletCANV2GetIdentity() throws TinkerforgeException;;
}
