/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the LCD 128x64 Bricklet.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletLCD128x64Actions {

    public void brickletLCD128x64WritePixels(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64ReadPixels(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException;

    public void brickletLCD128x64ClearDisplay() throws TinkerforgeException;

    public void brickletLCD128x64WriteLine(int line, int position, String text) throws TinkerforgeException;

    public void brickletLCD128x64DrawBufferedFrame(boolean forceCompleteRedraw) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetTouchPosition() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetTouchGesture() throws TinkerforgeException;

    public void brickletLCD128x64DrawLine(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean color) throws TinkerforgeException;

    public void brickletLCD128x64DrawBox(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, boolean color) throws TinkerforgeException;

    public void brickletLCD128x64DrawText(int positionX, int positionY, int font, boolean color, String text) throws TinkerforgeException;

    public void brickletLCD128x64SetGUIButton(int index, int positionX, int positionY, int width, int height, String text) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUIButton(int index) throws TinkerforgeException;

    public void brickletLCD128x64RemoveGUIButton(int index) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUIButtonPressed(int index) throws TinkerforgeException;

    public void brickletLCD128x64SetGUISlider(int index, int positionX, int positionY, int length, int direction, int value) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUISlider(int index) throws TinkerforgeException;

    public void brickletLCD128x64RemoveGUISlider(int index) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUISliderValue(int index) throws TinkerforgeException;

    public void brickletLCD128x64SetGUITabConfiguration(int changeTabConfig, boolean clearGUI) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUITabConfiguration() throws TinkerforgeException;

    public void brickletLCD128x64SetGUITabText(int index, String text) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUITabText(int index) throws TinkerforgeException;

    public void brickletLCD128x64SetGUITabIcon(int index, boolean[] icon) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUITabIcon(int index) throws TinkerforgeException;

    public void brickletLCD128x64RemoveGUITab(int index) throws TinkerforgeException;

    public void brickletLCD128x64SetGUITabSelected(int index) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUITabSelected() throws TinkerforgeException;

    public void brickletLCD128x64SetGUIGraphConfiguration(int index, int graphType, int positionX, int positionY, int width, int height, String textX, String textY) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUIGraphConfiguration(int index) throws TinkerforgeException;

    public void brickletLCD128x64SetGUIGraphData(int index, int[] data) throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetGUIGraphData(int index) throws TinkerforgeException;

    public void brickletLCD128x64RemoveGUIGraph(int index) throws TinkerforgeException;

    public void brickletLCD128x64RemoveAllGUI() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetDisplayConfiguration() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetTouchLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64ReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletLCD128x64Reset() throws TinkerforgeException;

    public Map<String, Object> brickletLCD128x64GetIdentity() throws TinkerforgeException;;
}
