/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the NFC Bricklet.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletNFCActions {

    public Map<String, Object> brickletNFCGetMode() throws TinkerforgeException;

    public void brickletNFCReaderRequestTagID() throws TinkerforgeException;

    public Map<String, Object> brickletNFCReaderGetTagID() throws TinkerforgeException;

    public Map<String, Object> brickletNFCReaderGetState() throws TinkerforgeException;

    public void brickletNFCReaderWriteNDEF(int[] ndef) throws TinkerforgeException;

    public void brickletNFCReaderRequestNDEF() throws TinkerforgeException;

    public Map<String, Object> brickletNFCReaderReadNDEF() throws TinkerforgeException;

    public void brickletNFCReaderAuthenticateMifareClassicPage(int page, int keyNumber, int[] key) throws TinkerforgeException;

    public void brickletNFCReaderWritePage(int page, int[] data) throws TinkerforgeException;

    public void brickletNFCReaderRequestPage(int page, int length) throws TinkerforgeException;

    public Map<String, Object> brickletNFCReaderReadPage() throws TinkerforgeException;

    public Map<String, Object> brickletNFCCardemuGetState() throws TinkerforgeException;

    public void brickletNFCCardemuStartDiscovery() throws TinkerforgeException;

    public void brickletNFCCardemuWriteNDEF(int[] ndef) throws TinkerforgeException;

    public void brickletNFCCardemuStartTransfer(int transfer) throws TinkerforgeException;

    public Map<String, Object> brickletNFCP2PGetState() throws TinkerforgeException;

    public void brickletNFCP2PStartDiscovery() throws TinkerforgeException;

    public void brickletNFCP2PWriteNDEF(int[] ndef) throws TinkerforgeException;

    public void brickletNFCP2PStartTransfer(int transfer) throws TinkerforgeException;

    public Map<String, Object> brickletNFCP2PReadNDEF() throws TinkerforgeException;

    public Map<String, Object> brickletNFCReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletNFCGetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletNFCGetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletNFCGetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletNFCReset() throws TinkerforgeException;

    public Map<String, Object> brickletNFCGetIdentity() throws TinkerforgeException;;
}
