/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Real-Time Clock Bricklet.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletRealTimeClockActions {

    public void brickletRealTimeClockSetDateTime(int year, short month, short day, short hour, short minute, short second, short centisecond, short weekday) throws TinkerforgeException;

    public Map<String, Object> brickletRealTimeClockGetDateTime() throws TinkerforgeException;

    public Map<String, Object> brickletRealTimeClockGetTimestamp() throws TinkerforgeException;

    public Map<String, Object> brickletRealTimeClockGetOffset() throws TinkerforgeException;

    public void brickletRealTimeClockSetAlarm(byte month, byte day, byte hour, byte minute, byte second, byte weekday, int interval) throws TinkerforgeException;

    public Map<String, Object> brickletRealTimeClockGetAlarm() throws TinkerforgeException;

    public Map<String, Object> brickletRealTimeClockGetIdentity() throws TinkerforgeException;;
}
