/**
 * Copyright (c) 2010-2020 Contributors to the openHAB project
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 */

 /* ***********************************************************
 * This file was automatically generated on 2022-01-03.      *
 *                                                           *
 * openHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.openhab.binding.tinkerforge.internal.device;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NonNull;
import org.openhab.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.Thing;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;

import com.tinkerforge.TinkerforgeException;

/**
 * Passes through actions of the Segment Display 4x7 Bricklet 2.0.
 *
 * @author Erik Fleckstein - Initial contribution
 */
@NonNullByDefault
public interface IBrickletSegmentDisplay4x7V2Actions {

    public void brickletSegmentDisplay4x7V2SetSegments(boolean[] digit0, boolean[] digit1, boolean[] digit2, boolean[] digit3, boolean[] colon, boolean tick) throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetSegments() throws TinkerforgeException;

    public void brickletSegmentDisplay4x7V2SetSelectedSegment(int segment, boolean value) throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetSelectedSegment(int segment) throws TinkerforgeException;

    public void brickletSegmentDisplay4x7V2SetBrightness(int brightness) throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetBrightness() throws TinkerforgeException;

    public void brickletSegmentDisplay4x7V2StartCounter(int valueFrom, int valueTo, int increment, long length) throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetCounterValue() throws TinkerforgeException;

    public void brickletSegmentDisplay4x7V2SetNumericValue(int[] value) throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2ReadUID() throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetChipTemperature() throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetStatusLEDConfig() throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetSPITFPErrorCount() throws TinkerforgeException;

    public void brickletSegmentDisplay4x7V2Reset() throws TinkerforgeException;

    public Map<String, Object> brickletSegmentDisplay4x7V2GetIdentity() throws TinkerforgeException;;
}
